lick = require "lick"
lick.reset = true

require "player.lua"

old_translated = player.translated

function love.load()
  mapLoader = require("AdvTiledLoader.Loader")
  mapLoader.path = "maps/"
  currentMap = mapLoader.load("map1.tmx")
  currentMap.TILE_SIZE = 16
  currentMap.solidTiles = getSolidTiles(currentMap)
  player.currentMap = currentMap

  currentMap.isSolid = function(x, y)
    for i = 1, #currentMap.solidTiles do
      if x >= currentMap.solidTiles[i].x and x <= currentMap.solidTiles[i].x + currentMap.TILE_SIZE and y >= currentMap.solidTiles[i].y and y <= currentMap.solidTiles[i].y + currentMap.TILE_SIZE then
        return true
      end
    end

    return false
  end

  myCanvas = love.graphics.newCanvas(800, 640)
end

function love.update(dt)
  player.dt = dt

  if love.keyboard.isDown("escape") then
    love.event.quit()
  end

  if love.keyboard.isDown("right") then
    player.vx = 2
  end
  if love.keyboard.isDown("left") then
    player.vx = -2
  end

  if not player.collidingBelow(currentMap) then
    player.y_acc = 0.2
    --else
    --player.y_acc = 0
    --player.vy = 0
  end

  if love.keyboard.isDown("up") then
    if player.canJump and player.collidingBelow(currentMap) then
      player.y_acc = -10
      player.canJump = false
    end
  else
    player.canJump = true
  end

  player.update()
end

function love.draw()
  currentMap:setDrawRange(player.translated, 0, 800, 640)
  love.graphics.translate(-player.translated, 0)

  --love.graphics.setCanvas(myCanvas)
  --currentMap:draw()
  --love.graphics.setCanvas()

  love.graphics.push()
  currentMap:draw()
  love.graphics.pop()

  love.graphics.draw(myCanvas, 0, 0)
  love.graphics.draw(player.image, player.x, player.y)
end

function getSolidTiles(map)
  local collidableTiles = {}

  local layer = map.tl["map"]

  for tileX, tileY, tile in layer.tileData:iterate() do
    if tile and tile.properties.type == "block" then
      local tile = {}
      tile.x = tileX * map.TILE_SIZE
      tile.y = tileY * map.TILE_SIZE

      table.insert(collidableTiles, tile)
    end
  end

  return collidableTiles
end
