player = {}
player.x = 800 / 2 - 16 / 2
player.y = 20
player.vx = 0
player.vy = 0
player.y_acc = 0
player.canJump = true
player.width = 16
player.height = 16 
player.image = love.graphics.newImage("img/player.png")
player.currentMap = nil
player.translated = 0

player.update = function()
  player.vy = player.vy + player.y_acc
  
  if player.vx > 0 then
    for i = 0, player.vx - 1 do
      if player.collidingRight(player.currentMap) then
        player.vx = 0
      else
        player.x = player.x + 1
        player.translated = player.translated + 1
      end
    end
  else
    for i = 0, math.abs(player.vx) - 1 do
      if player.collidingLeft(player.currentMap) then
        player.vx = 0
      else
        player.x = player.x - 1
        player.translated = player.translated - 1
      end
    end
  end

  if player.vy > 0 then
    for i = 0, player.vy - 1 do
      if player.collidingBelow(player.currentMap) then
        player.vy = 0
      else
        player.y = player.y + 1
      end
    end
  else
    for i = 0, math.abs(player.vy) - 1 do
      if player.collidingAbove(player.currentMap) then
        player.vy = 0
      else
        player.y = player.y - 1
      end
    end
  end

  -- Horizontal friction
  if player.vx > 0 then player.vx = player.vx - 0.1 end
  if player.vx < 0 then player.vx = player.vx + 0.1 end
  if math.abs(player.vx) < 0.1 then player.vx = 0 end

  -- Vertical friction
  if player.y_acc > 0 then player.y_acc = player.y_acc - 0.1 end
  if player.y_acc < 0 then player.y_acc = player.y_acc + 0.1 end
  if math.abs(player.y_acc) < 0.1 then player.y_acc = 0 end
end

player.collidingBelow = function(map)
  for i = 1, map.TILE_SIZE - 1 do
    if map.isSolid(player.x + i, player.y + map.TILE_SIZE) then
      return true
    end
  end

  return false
end

player.collidingAbove = function(map)
  for i = 1, map.TILE_SIZE - 1 do
    if map.isSolid(player.x + i, player.y) then
      return true
    end
  end

  return false
end

player.collidingRight = function(map)
  for i = 1, map.TILE_SIZE - 1 do
    if map.isSolid(player.x + map.TILE_SIZE, player.y + i) then
      return true
    end
  end

  return false
end

player.collidingLeft = function(map)
  for i = 1, map.TILE_SIZE - 1 do
    if map.isSolid(player.x, player.y + i) then
      return true
    end
  end

  return false
end
